# to work with set of installed packages

image_clean()
{
    if [ -d "${D}" ] ; then
        rm -rf "${D}"
    fi
}

image_remove_la()
{
    find ${D} -name "*.la" | xargs rm -rf
}

image_create_rules()
{
    mkdir -p ${T}
    : > ${T}/${edit_RULES_FILE}
    printf "%s\n" "s#(${ROOT})+##g" >> ${T}/${edit_RULES_FILE}
}

image_setup_paths()
{
    alog "Preparing files for native package"

    image_create_rules

    find ${D} -type f | grep -v -e "\.h$" | filter_text_files | edit_by_rules
}

image_split_pack()
{
    return
}

image_strip_set()
{
    names="$1"
    stripoptions="$2"

    if test -z "${names}" ; then
        return
    fi

    nonwritable="$(find ${names} -perm -u-w)"
    if test -n "${nonwritable}" ; then
        chmod u+w ${nonwritable}
    fi

    "${strip_IMAGE}" ${stripoptions} ${names}

    if test -n "${nonwritable}" ; then
        chmod u-w ${nonwritable}
    fi
}

image_strip_bin()
{
    if test -z "${STRIP}" -a -n "${AR}" ; then
        awarn "Looks like non-default toolchain is used (AR variable is initialised).
But variable \${STRIP} is not initialised.
That can lead to incorrect work of strip and possible failures of the build."
    fi
    strip_IMAGE="${STRIP:-strip}"
    libdirs=
    execdirs=
    for pref in ${PREFIX_LIST} ; do
        for single_dir in ${image_TRACKED_LIB_DIRS} ; do
            if test -d "${D}${pref}/${single_dir}" ; then
                libdirs="${libdirs} ${D}${pref}/${single_dir}"
            fi
        done
        for single_dir in ${image_TRACKED_EXEC_DIRS} ; do
            if test -d "${D}${pref}/${single_dir}" ; then
                execdirs="${execdirs} ${D}${pref}/${single_dir}"
            fi
        done
    done

    names="$(binfiles -s ${libdirs})"
    image_strip_set "${names}" '--strip-debug'
    names="$(binfiles -d ${libdirs})"
    image_strip_set "${names}" '--strip-unneeded'
    names="$(binfiles ${execdirs})"
    image_strip_set "${names}" '--strip-all'
}
