

# ----------- engine methods ------------------

aplain_config_cache_create()
{
    if [ ! -d ${APLAIN_SRCDIR}/ ] ; then
        return 0
    fi

    cache_file="${CONFIGCACHE}"
    mkdir -p $(dirname ${CONFIGCACHE})
    : > ${cache_file}
    for word in ${AUSE} ; do
        if [ -f ${APLAIN_SRCDIR}/${word}.config.cache ] ; then
            cat ${APLAIN_SRCDIR}/${word}.config.cache >> ${cache_file}
        fi
    done
    
    if [ -z "$(cat ${cache_file} | head -1)" ] ; then
        rm -f ${cache_file}
    fi
}

aplain_config_cache_install()
{
    if [ -f "${CONFIGCACHE}" ] ; then
        find ${S} -name "configure" | while read linefile ; do
            dirconf=$(dirname ${linefile})
            cp -fp ${CONFIGCACHE} ${dirconf}/
        done
    fi
}

aplain_config_sub_install()
{
    guess_file=
    sub_file=
    if [ -f "${APLAIN_SRCDIR}/config.guess" ] ; then
        guess_file="${APLAIN_SRCDIR}/config.guess"
    fi
    if [ -f "${APLAIN_SRCDIR}/config.sub" ] ; then
        sub_file="${APLAIN_SRCDIR}/config.sub"
    fi

    if [ -n "${guess_file}" -o -n "${sub_file}" ] ; then
        find ${S} -name "config.sub" -o -name "config.guess" | while read linefile ; do
            if [ "$(basename ${linefile})" = 'config.guess' ] ; then
                if [ -n "${guess_file}" ] ; then
                    cp -pf ${guess_file} ${linefile}
                    chmod 755 ${linefile}
                fi
            else
                if [ -n "${sub_file}" ] ; then
                    cp -pf ${sub_file} ${linefile}
                    chmod 755 ${linefile}
                fi
            fi
        done
    fi
}

# ----------- map interfaces ------------------

patches_auto()
{
    aplain_config_cache_create
    aplain_config_cache_install

    aplain_config_sub_install
}

