#!/bin/sh

COPY=${COPY:-"cp -Rf"}
MKDIR=${MKDIR:-"mkdir -p"}
DESTDIR=${DESTDIR:-"${HOME}/rrr"}
P=${P:-"any"}
DOCDIR="${DOCDIR:-${PREFIX}/share/doc/${P}}"
MANDIR="${MANDIR:-${PREFIX}/share/man}"

set -o xtrace

${MKDIR} \
    "${DESTDIR}${DOCDIR}/" \
    "${DESTDIR}${MANDIR}/"

# all separate tools are already here with needed dir structure
${COPY} rrr/* "${DESTDIR}/"

# the core engine, reinstall, as it can be changed
(
cd any
./install.sh "${@}"
)

# integrated docs
if test -d doc/html/ ; then
    ${COPY} doc/html/ "${DESTDIR}${DOCDIR}/"
fi
if test -d doc/man/ ; then
    ${COPY} \
        doc/man/man1/ \
        doc/man/man3/ \
        doc/man/man7/ \
        "${DESTDIR}${MANDIR}/"
fi
