#
# script to make release archive from all subprojects.
#

VERSION="${VERSION:-0.11.9}"
basedir="${BASEDIR:-$(pwd)}"
releasedir="${RELEASEDIR:-$(pwd)/any-${VERSION}}"

rm -rf ${releasedir}
mkdir -p ${releasedir}
git clone ${basedir}/any ${releasedir}/any
rm -rf ${releasedir}/any/.git
cp -Rf ${releasedir}/any/example.conf.d ${releasedir}/rdd.conf.d
install -m644 ${releasedir}/any/example.rdd.def ${releasedir}/rdd.def
install -m644 ${releasedir}/any/rel-README-any ${releasedir}/README-any
install -m755 ${releasedir}/any/rel-install.sh ${releasedir}/install.sh

(
cd ${releasedir}/any
DESTDIR=${releasedir}/rrr ./install.sh
)
(
cd ${basedir}/subcom
DESTDIR=${releasedir}/rrr ./install.sh
)
(
cd ${basedir}/mods
ADIR=${releasedir} DESTDIR=${releasedir}/rrr ./install.sh
)
(
cd ${basedir}/utils
DESTDIR=${releasedir}/rrr ./install.sh
)
(
cd ${basedir}/devdoc
DESTDIR=${releasedir}/rrr ./install.sh
)
(
cd ${basedir}/rdd-py
DESTDIR=${releasedir}/rrr ./install.sh
)

cp -Rf ${basedir}/works/any-lfs/ ${releasedir}/lfs/
rm -rf ${releasedir}/lfs/.git ${releasedir}/lfs/ports/.git 

# render documentation

cp -Rf ${basedir}/mods/self/srcdoc ${releasedir}/any/srcdoc/mods
for dir in ${basedir}/mods/* ; do
    if test -d ${dir}/srcdoc ; then
        modname=$(basename ${dir})
        cp -Rf ${dir}/srcdoc ${releasedir}/any/srcdoc/mods/${modname}
    fi
done
rm -rf ${releasedir}/any/srcdoc/mods/self/
cp -Rf ${basedir}/subcom/srcdoc ${releasedir}/any/srcdoc/subcom
cp -Rf ${basedir}/utils/srcdoc ${releasedir}/any/srcdoc/utils
cp -Rf ${basedir}/devdoc/srcdoc ${releasedir}/any/srcdoc/devdoc
cp -Rf ${basedir}/rdd-py/srcdoc ${releasedir}/any/srcdoc/rdd

mkdir -p ${releasedir}/doc
devdoc -t ${releasedir}/any/srcdoc/html-template -f "html man" ${releasedir}/any/srcdoc
mv var/html ${releasedir}/doc/html
mv var/man ${releasedir}/doc/man
